/*
 *	conio.h
 *	Author: Jakash3, n0n3m4
 */

#ifndef CONIO_H
#define CONIO_H
 
#include <stdio.h>
#include <unistd.h>
#include <termios.h>
#include <sys/select.h>

static void terminal_lnbuf(int yn) {
   struct termios oldt, newt;
   tcgetattr(0, &oldt);
   newt = oldt;
   if (!yn) newt.c_lflag &= ~ICANON;
   else newt.c_lflag |= ICANON;
   tcsetattr(0, TCSANOW, &newt);
}
 
static void terminal_echo(int yn) {
   struct termios oldt, newt;
   tcgetattr(0, &oldt);
   newt = oldt;
   if (!yn) newt.c_lflag &= ~ECHO;
   else newt.c_lflag |= ECHO;
   tcsetattr(0, TCSANOW, &newt);
}
	 
static void gotoxy(int x, int y) { printf("\x1B[%d;%df", y, x); fflush(stdout); }

static void _gotoxy(int x,int y) {gotoxy(x,y);}
	 
static void clrscr() { printf("\x1B[2J\x1B[0;0f"); fflush(stdout); }

static void _clrscr() {clrscr();}
	 
static int getch() {
   register int ch;
   terminal_lnbuf(0);
   terminal_echo(0);
   ch = getchar();
   terminal_lnbuf(1);
   terminal_echo(1);
   return ch;
}

static int _getch() {return getch();}
	 
static int getche() {
   register int ch;
   terminal_lnbuf(0);
   ch = getchar();
   terminal_lnbuf(1);
   return ch;
}

#define BLACK	 		0
#define BLUE 			1
#define GREEN	 		2
#define CYAN 			3
#define RED	 			4
#define MAGENTA 		5
#define BROWN 			6
#define LIGHTGRAY 		7
#define DARKGRAY 		8
#define LIGHTBLUE 		9
#define LIGHTGREEN 		10
#define LIGHTCYAN 		11
#define LIGHTRED 		12
#define LIGHTMAGENTA	13
#define YELLOW 			14
#define WHITE 			15

#define cprintf printf

static char* _conio_fgcolor = "39";
static char* _conio_bgcolor = "49";

static void textcolor(int color)
{
	static char* fgs[] = {"30","34","32","36","31","35","33","37","90","94","92","96","91","95","93","97"};	
	if (color < 0 || color >= sizeof(fgs)/sizeof(char*))
		_conio_fgcolor = "39";
	else
		_conio_fgcolor = fgs[color];
	printf("\033[0;%s;%sm",_conio_fgcolor,_conio_bgcolor);
	fflush(stdout);
}

static void textbackground(int color)
{
	static char* bgs[] = {"40","44","42","46","41","45","43","47","100","104","102","106","101","105","103","107"};	
	if (color < 0 || color >= sizeof(bgs)/sizeof(char*))
		_conio_bgcolor = "49";
	else
		_conio_bgcolor = bgs[color];
	printf("\033[0;%s;%sm",_conio_fgcolor,_conio_bgcolor);
	fflush(stdout);
}

static int _getche() {return getche();}

static int kbhit() {
   register int ret;
   fd_set fds;
   terminal_lnbuf(0);
   terminal_echo(0);
   struct timeval tv;
   tv.tv_sec = 0;
   tv.tv_usec = 0;
   FD_ZERO(&fds);
   FD_SET(0, &fds);
   select(1, &fds, 0, 0, &tv);
   ret = FD_ISSET(0, &fds);
   terminal_lnbuf(1);
   terminal_echo(1);
   return ret;
}

static int _kbhit() {return kbhit();}
#endif
