/*
	Copyright (C) 2020 n0n3m4 (Roman Lebedev)
	All rights reserved.
	Redistribution and use is allowed only by written personal permission of n0n3m4 (Roman Lebedev).
	Any other use is prohibited
*/

/*
	This file is a part of Backcompat library for Android.
*/

#ifndef BACKCOMPAT_STDIO_H
#define BACKCOMPAT_STDIO_H

#define popen __backcompat_orig_popen
#define pclose __backcompat_orig_pclose

#include_next <stdio.h>

#undef popen
#undef pclose

#define popen backcompat_popen
#define pclose backcompat_pclose

#ifndef __BEGIN_DECLS
#ifdef   __cplusplus
# define __BEGIN_DECLS  extern "C" {                                            
# define __END_DECLS }
#else
# define __BEGIN_DECLS
# define __END_DECLS
#endif
#endif

__BEGIN_DECLS

FILE* popen(const char* command, const char* mode);
int pclose(FILE* fp);

#ifndef LIBBACKCOMPAT_BUILDING

#undef popen
#undef pclose

static __inline__ __attribute__((__always_inline__)) FILE* popen(const char* command, const char* mode)
{
	return backcompat_popen(command, mode);
}

static __inline__ __attribute__((__always_inline__)) int pclose(FILE* fp)
{
	return backcompat_pclose(fp);
}

#endif

__END_DECLS

#endif
