#ifndef WINDOWS_H
#define WINDOWS_H
#warning Trying to use Windows header on Android is not wise
#include <unistd.h>
#include <conio.h>
#include <string.h>
#include <errno.h>

#ifndef DWORD
#define WINAPI
typedef unsigned int DWORD;
typedef short WCHAR;
typedef void * HANDLE;
#define MAX_PATH PATH_MAX
typedef unsigned char BYTE;
typedef unsigned short WORD;
typedef unsigned short SHORT;
typedef unsigned int BOOL;
typedef void VOID;

typedef const char * LPCTSTR;
typedef const char * LPCSTR;
typedef const char * LPCWSTR;

typedef char * LPTSTR;
typedef char * LPSTR;
typedef char * LPWSTR;

typedef void * LPVOID;
typedef const void *LPCVOID;

typedef unsigned int * LPDWORD;
typedef const unsigned int * LPCDWORD;

typedef struct _COORD {
  SHORT X;
  SHORT Y;
} COORD, *PCOORD;
#endif

// Some functions that make windows.h look working
// Redistribution of this header is not allowed without the permission of IIEC

int strcpy_s(char* dst, size_t size, const char* src)
{
	if(!dst || !src) return EINVAL;
	for(;size > 0;--size)
	{
		if(!(*dst++ = *src++)) return 0;
	}
	return ERANGE;
}

#define STD_INPUT_HANDLE 0
#define STD_OUTPUT_HANDLE 1
#define STD_ERROR_HANDLE 2

HANDLE WINAPI GetStdHandle(DWORD nStdHandle)
{
	return (void*)nStdHandle;
}

BOOL OemToCharA(LPCSTR pSrc, LPSTR pDst)
{
	// Everything is Unicode on Android
	if (pDst != pSrc)
		strcpy(pDst,pSrc);
	return 1;
}

BOOL WINAPI SetConsoleCursorPosition(HANDLE hConsoleOutput, COORD dwCursorPosition)
{
	gotoxy(dwCursorPosition.X,dwCursorPosition.Y);
	return 1;
}

#define FOREGROUND_BLUE 0x0001
#define FOREGROUND_GREEN 0x0002
#define FOREGROUND_RED 0x0004
#define FOREGROUND_INTENSITY 0x0008
#define BACKGROUND_BLUE 0x0010
#define BACKGROUND_GREEN 0x0020
#define BACKGROUND_RED 0x0040
#define BACKGROUND_INTENSITY 0x0080

BOOL WINAPI SetConsoleTextAttribute(HANDLE hConsoleOutput, WORD wAttributes)
{
	textcolor(wAttributes & (FOREGROUND_BLUE | FOREGROUND_GREEN | FOREGROUND_RED | FOREGROUND_INTENSITY));
	textbackground((wAttributes & (BACKGROUND_BLUE | BACKGROUND_GREEN | BACKGROUND_RED | BACKGROUND_INTENSITY)) >> 4);
	return 1;
}

static void Sleep(DWORD dwMilliseconds)
{
	usleep(dwMilliseconds * 1000);
}

BOOL WINAPI WriteConsole(HANDLE hConsoleOutput,const void *lpBuffer,DWORD nNumberOfCharsToWrite,LPDWORD lpNumberOfCharsWritten,LPVOID lpReserved)
{
	*lpNumberOfCharsWritten = (DWORD) write((int)((long)hConsoleOutput),lpBuffer,nNumberOfCharsToWrite);
	return 1;
}

BOOL WINAPI ReadConsole(HANDLE hConsoleInput,void *lpBuffer,DWORD nNumberOfCharsToRead,LPDWORD lpNumberOfCharsRead,LPVOID pInputControl)
{
	*lpNumberOfCharsRead = (DWORD) read((int)((long)hConsoleInput),lpBuffer,nNumberOfCharsToRead);
	return 1;
}
#endif
